import {Component, EventEmitter, Input, OnDestroy, OnChanges, OnInit, Output, ApplicationRef} from '@angular/core';



@Component({
  selector: 'app-form',
  templateUrl: './form.component.html',
  styleUrls: ['./form.component.scss']
})
export class FormComponent implements OnInit, OnChanges, OnDestroy {

  // 储存数据用
  saveKey = "ym_018";
  // 储存对象
  item;

  word_arr = [];

  constructor(private appRef: ApplicationRef) {

  }


  ngOnInit() {

    this.item = {};

    this.item.title = {
      t_val:'1'
    };

    this.item.words = this.word_arr;

    // 获取存储的数据
    (<any> window).courseware.getData((data) => {

      if (data) {
        this.item = data;
      }

      console.log('item', this.item);

      this.init();
      this.refresh();

    }, this.saveKey);

  }


  ngOnChanges() {
  }

  ngOnDestroy() {
  }



  init() {

    //标题
    if(!this.item.title){
      this.item.title = {
        t_val:'1'
      };
    }

    if(!this.item.words){
      this.item.words = this.word_arr;
    }
    else{
      this.word_arr = this.item.words;
    }
  }


  /**
   * 储存图片数据
   * @param e
   */
  onImageUploadSuccess(e, item, key) {

      item[key] = e.url;
      this.save();
  }

  /**
   * 储存音频数据
   * @param e
   */
  onAudioUploadSuccess(e, item, key) {

    item[key] = e.url;
    this.save();
  }



  /**
   * 储存数据
   */
  save() {
    console.log('item', this.item);
    (<any> window).courseware.setData(this.item, null, this.saveKey);
    this.refresh();
  }

  /**
   * 刷新 渲染页面
   */
  refresh() {
    setTimeout(() => {
      this.appRef.tick();
    }, 1);
  }

  wordItemData(){
    return {
      word_val: "",
      word_audio_url: ""
    };
  }

  /**
   * 添加单词项
   */
  addWordItem(){
    let word = this.wordItemData();

    this.word_arr.push(word);

    this.save();
  }

  /**
   * 删除数组指定索引项
   * @param arrItem 数组对象
   * @param index 索引
   */
  deleteArrItem(arrItem, index){
    if (index !== -1) {
      arrItem.splice(index, 1);
    }
    this.save();
  }
}

